package org.globalse.oose.bumpers;

import java.applet.Applet;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.net.URL;
import javax.swing.JPanel;
import org.globalse.oose.bumpers.cars.Car;
import org.globalse.oose.bumpers.cars.DrivenCar;
import org.globalse.oose.bumpers.cars.FastCar;
import org.globalse.oose.bumpers.cars.SlowCar;
import org.globalse.oose.bumpers.cars.instruments.SpeedController;
import org.globalse.oose.bumpers.control.Referee;
import org.globalse.oose.bumpers.ui.Game;

public class Start {
	
	public static void main(String[] args) {
		
		try {
			Car.DEFAULT_IMAGE = loadImage("FastCar.gif");
			DrivenCar.DEFAULT_IMAGE = loadImage("A-Klasse.gif");
			FastCar.DEFAULT_FAST_CAR_IMAGE = loadImage("SLK.gif");
			SlowCar.DEFAULT_SLOW_CAR_IMAGE = loadImage("Kaefer.gif");
			SpeedController.UP = loadImage("up.gif");
			SpeedController.DOWN = loadImage("down.gif");
			Referee.MUSIC = Applet.newAudioClip(Start.class.getResource("Music.au"));
			Referee.BANG = Applet.newAudioClip(Start.class.getResource("Bang.au"));
			
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
		
		
		
		Game bumperWindow = new Game();
		bumperWindow.pack();
		bumperWindow.show();
	}
	
	private static Image loadImage(String name) throws Exception {
		URL url = Start.class.getResource(name);
		MediaTracker m = new MediaTracker(new JPanel());
		Image img = Toolkit.getDefaultToolkit().getImage(url);
		m.addImage(img, 0);
		m.waitForAll();
		return img;
	}
	
}


