package org.globalse.oose.bumpers.cars;

import java.awt.Image;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.globalse.oose.bumpers.ui.InstrumentPanel;

public class DrivenCar extends Car {
	public static Image DEFAULT_IMAGE;
	
	private ArrayList instruments = new ArrayList();
	
	private InstrumentPanel instrumentPanel;
	
	public DrivenCar(){
		super();
		instrumentPanel = new InstrumentPanel(this);
	}
	
	public void initiate(int max_x, int max_y) {
		setBody(DEFAULT_IMAGE);
		this.position.x = 0;
		this.position.y = max_y;
		setDirection(90);
		this.speed = 5;
		this.isCrunched = false;
		notifyInstruments();
	}
	
	public void subscribeInstrument(Instrument component){
		if(component != null &&
		   !this.instruments.contains(component)){
			this.instruments.add(component);
		}
	}
	
	public void unsubscribeInstrument(Instrument instrument){
		if(instrument != null &&
		   this.instruments.contains(instrument)){
			this.instruments.remove(instrument);
		}
	}
	
	public synchronized void notifyInstruments(){
		Iterator iter = instruments.iterator();
		while (iter.hasNext()) {
			Instrument aComponent = (Instrument)iter.next();
			aComponent.updateIntrument();
		}
	}
	
	public List getInstruments(){
		return instruments;
	}
	
	
	public synchronized void updatePosition(int max_x, int max_y) {
		super.updatePosition(max_x, max_y);
		notifyInstruments();
	}
	
	public InstrumentPanel getInstrumentPanel(){
		return this.instrumentPanel;
	}
}

