package org.globalse.oose.bumpers.cars.instruments;

import org.globalse.oose.bumpers.cars.DrivenCar;
import org.globalse.oose.bumpers.cars.Instrument;

public class AnalogSpeedometerAdapter extends Instrument{
	
	private AnalogSpeedometer speedometer;
	private int speed;
	
	public AnalogSpeedometerAdapter(DrivenCar theCar,
									AnalogSpeedometer speedometer){
		super(theCar);
		this.speedometer = speedometer;
		updateIntrument();
	}
	
	
	public void updateIntrument() {
		if(this.speed != theCar.getSpeed()){
			this.speed = theCar.getSpeed();
			
			double percent = (double)theCar.MAX_SPEED/100*this.speed;
			int angle = (int)(speedometer.getMaxAngle()*percent);
			this.speedometer.setAngle(angle);
		}
	}
	
	
}

