package org.globalse.oose.bumpers.cars.instruments.eu;

import org.globalse.oose.bumpers.cars.instruments.InstrumentFactory;
import org.globalse.oose.bumpers.cars.instruments.Body;
import org.globalse.oose.bumpers.cars.instruments.GPS;
import org.globalse.oose.bumpers.cars.instruments.RotationsPerSecond;
import org.globalse.oose.bumpers.cars.instruments.Speedometer;
import org.globalse.oose.bumpers.cars.instruments.SpeedController;
import org.globalse.oose.bumpers.cars.DrivenCar;

public class EUFactory extends InstrumentFactory {
	
	private static EUFactory INSTANCE;
	
	private EUFactory(){}
	
	public static InstrumentFactory getInstance(){
		if(INSTANCE == null){
			INSTANCE = new EUFactory();
		}
		return INSTANCE;
	}
	public RotationsPerSecond createRotationsPerSecond(DrivenCar theCar) {
		return new EURotationsPerSecond(theCar);
	}
	
	public SpeedController createSpeedController(DrivenCar theCar) {
		return new EUSpeedController(theCar);
	}
	
	public Speedometer createSpeedometer(DrivenCar theCar) {
		return new EUSpeedometer(theCar);
	}
	
	public Body createBodyView(DrivenCar theCar) {
		return new EUBody(theCar);
	}
	
	public GPS createGPS(DrivenCar theCar) {
		return new EUGPS(theCar);
	}
}

