package org.globalse.oose.bumpers.ui;

import javax.swing.*;

import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.Iterator;
import org.globalse.oose.bumpers.control.CollisionStrategy;
import org.globalse.oose.bumpers.control.Referee;

public class ToolBar extends JToolBar implements ItemListener {
	
	
	
	private Action startBumperAction;
	private Action stopBumperAction;
	
	private JComboBox strategyBox = new JComboBox();
	
	private static ToolBar INSTANCE;
	
	public static ToolBar getInstance(){
		if(INSTANCE == null){
			INSTANCE = new ToolBar();
		}
		return INSTANCE;
	}
	
	private ToolBar(){
		super();
		
		ArrayList strategies = CollisionStrategy.getSTRATEGIES();
		Iterator iter = strategies.iterator();
		while (iter.hasNext()) {
			strategyBox.addItem(iter.next());
		}
		strategyBox.setSelectedItem(Referee.getInstance().getCollisionStrategy());
		strategyBox.addItemListener(this);
		
		setFloatable(false);
		initActions();
		add(startBumperAction);
		add(stopBumperAction);
		addSeparator();
		add(new JLabel("Collision Strategy:"));
		add(strategyBox);
		enableButtons();
	}
	
	private void initActions() {
		startBumperAction = new AbstractAction("start"){
			public void actionPerformed(ActionEvent e) {
				Referee.getInstance().startGame();
			}};
		
		stopBumperAction = new AbstractAction("stop"){
			public void actionPerformed(ActionEvent e) {
				Referee.getInstance().stopGame();
				int ret = JOptionPane.showConfirmDialog(null,
														"Do you really want to stop the game ?",
														"Stop Game Confirmation",
														JOptionPane.YES_NO_OPTION);
				if(ret == 0){
					Referee.getInstance().initGame();
					
				}else{
					Referee.getInstance().startGame();
				}
			}};
	}
	
	public void enableButtons(){
		if(Referee.getInstance().isRunning()){
			startBumperAction.setEnabled(false);
			stopBumperAction.setEnabled(true);
		}else{
			startBumperAction.setEnabled(true);
			stopBumperAction.setEnabled(false);
		}
	}
	
	public void itemStateChanged(ItemEvent e) {
		CollisionStrategy selectedCollision = (CollisionStrategy)strategyBox.getSelectedItem();
		Referee.getInstance().setCollisionStrategy(selectedCollision);
	}
}

